/**
   A class that implements the ADT set by using an array.
   
   @author Frank M. Carrano
   @version 4.0
*/
public class ArraySet<T> implements SetInterface<T> 
{
	private ResizableArrayBag<T> bagOfSetEntries; 

	public ArraySet()
	{
		bagOfSetEntries = new ResizableArrayBag<>();
	} // end default constructor

	public void clear() 
	{
		bagOfSetEntries.clear();
	} // end clear

	public boolean add(T newEntry) 
	{
		boolean result = false;
		
		if (!bagOfSetEntries.contains(newEntry))
		{
			result = bagOfSetEntries.add(newEntry);
		} // end if
		
		return result;
	} // end add

 	public boolean remove(T anEntry) 
	{
		return bagOfSetEntries.remove(anEntry);
	} // end remove

 	public T remove() 
	{
		return bagOfSetEntries.remove();
	} // end remove

	public boolean contains(T anEntry) 
	{
		return bagOfSetEntries.contains(anEntry);
	} // end contains

 	public int getCurrentSize() 
	{
		return bagOfSetEntries.getCurrentSize();
	} // end getCurrentSize

	public boolean isEmpty() 
	{
		return bagOfSetEntries.isEmpty();
	} // end getLength

	public T[] toArray() 
	{
		return bagOfSetEntries.toArray();
	} // end toArray
} // end ArraySet
