/**
   Chapter 2, Project3.
   
   @author Frank Carrano
   @author Karen Gardner
   @version 4.0
*/
public class Project3
{
	public static void main(String[] args)
	{
		String[] contentsOfBag = {"A", "B", "C", "D", "A", "C", "B", "B"};
		ArraySet<String> aBag = new ArraySet<>(contentsOfBag);
 		displayBag(aBag);

 		// We destroy the bag; to avoid doing so, make a copy of it
		SetInterface<String> aSet = new ArraySet<>();

		while (!aBag.isEmpty())
			aSet.add(aBag.remove());
		displaySet(aSet);

		SetInterface<String> set1 = new ArraySet<>();
		SetInterface<String> set2 = new ArraySet<>();
		
		// Initial capacity is 3
		System.out.println("Set 1 initially empty, capacity of 3 is ");
		displaySet(set1);

		set1.add("A");
		set1.add("A");
		set1.add("B");
		set1.add("A");
		set1.add("C");
		set1.add("A");

		System.out.println("Set 1 after adding elements is ");
		displaySet(set1);

		set1.add("V");
		set1.add("V");
		set1.add("T");
		set1.add("U");
		set1.add("V");
		set1.add("W");
		set1.add("X");
		set1.add("Y");
		set1.add("Z");

		System.out.println("Set 1 after adding and resizing is ");
		displaySet(set1);

		set2.add("A");
		set2.add("B");
		set2.add("B");
		set2.add("A");
		set2.add("C");
		set2.add("C");
		set2.add("D");
		set2.add("E");
		set2.add("F");
		set2.add("G");
		set2.add("H");

		System.out.println("Set 2 after adding and resizing is ");
		displaySet(set2);

		System.out.println("Set 1 contains A: " + set1.contains("A"));
		System.out.println("Set 1 contains E: " + set1.contains("E"));

		set1.remove("B");
		System.out.println("After removing B from set 1, it contains");
		displaySet(set1);

		System.out.println("After removing " + set1.remove()
				+ " from set 1, it contains");
		displaySet(set1);
	} // end main

	// Displays a bag.
	private static void displayBag(BagInterface<String> aBag)
	{
		System.out.println("The bag contains " + aBag.getCurrentSize()
				+ " string(s), as follows:");
		Object[] bagArray = aBag.toArray();
		for (int index = 0; index < bagArray.length; index++)
		{
			System.out.print(bagArray[index] + " ");
		} // end for

		System.out.println();
	} // end displayBag

	// Displays a set.
	private static void displaySet(SetInterface<String> aSet)
	{
		System.out.println("The set contains " + aSet.getCurrentSize()
				+ " string(s), as follows:");
		Object[] setArray = aSet.toArray();
		for (int index = 0; index < setArray.length; index++)
		{
			System.out.print(setArray[index] + " ");
		} // end for

		System.out.println();
	} // end displaySet

} // end Project3

/*
The bag contains 8 string(s), as follows:
A B C D A C B B
The set contains 4 string(s), as follows:
B C A D
Set 1 initially empty, capacity of 3 is
The set contains 0 string(s), as follows:

Set 1 after adding elements is
The set contains 3 string(s), as follows:
A B C
Set 1 after adding and resizing is
The set contains 10 string(s), as follows:
A B C V T U W X Y Z
Set 2 after adding and resizing is
The set contains 8 string(s), as follows:
A B C D E F G H
Set 1 contains A: true
Set 1 contains E: false
After removing B from set 1, it contains
The set contains 9 string(s), as follows:
A Z C V T U W X Y
After removing Y from set 1, it contains
The set contains 8 string(s), as follows:
A Z C V T U W X
*/