import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
/** 
   Chapter 2, Project6.
   
   @author Frank M. Carrano
   @version 4.0
 */
public class Project6
{
	public static void main(String[] args) 
	{
		TextFileOperations.createTextFile("dictionary", 10);
		TextFileOperations.createTextFile("document", 5);

		SpellChecker checker = new SpellChecker();
		checker.setDictionary(new File("dictionary"));

		try
		{
			// Read document; check spelling of its words
			Scanner fileData = new Scanner(new File("document"));

			while (fileData.hasNextLine())
			{
				String word = fileData.nextLine();
				if (checker.checkSpelling(word))
					System.out.println(word + " is spelled correctly.");
				else
					System.out.println(word + " is incorrectly spelled.");
			} // end while

			fileData.close();
		}
		catch (FileNotFoundException e)
		{
			System.out.println("Error opening document.");
		}
	} // end main
} // end Project6

/*
Enter 10 lines of data:
Line 1: able
Line 2: baker
Line 3: gamma
Line 4: delta
Line 5: epsilon
Line 6: green
Line 7: red
Line 8: blue
Line 9: yellow
Line 10: white
Enter 5 lines of data:
Line 1: gama
Line 2: dalta
Line 3: yallow
Line 4: blue
Line 5: white
gama is incorrectly spelled.
dalta is incorrectly spelled.
yallow is incorrectly spelled.
blue is spelled correctly.
white is spelled correctly.
 */